.nolist
.include "m8def.inc"
.include "nrf24l01.inc"
.list

.cseg
.org 0000
rjmp init ;reset 
rjmp isr0 ;int0
rjmp isr1 ;reti ;int1
reti ;timer2 comp
reti ;timer2 overflow
reti ;timer1 capture
reti ;timer1 compare A
reti; timer1 compare N
reti ;timer1 overflow
reti ;timer0 overflow
reti ;SPI serial transfer complete
reti ;USART rx complete
reti ;USART DR empty
reti ;USART tx complete
reti ;ADC complete
reti ;eeprom ready
reti ;analog comparator
reti ;two wire interface
reti ;store program memory ready


init:
;INIT STACK
	ldi r16, HIGH(RAMEND) ; Oberes Byte
	out SPH, r16 ; an Stapelzeiger
	ldi r16, LOW(RAMEND) ; Unteres Byte
	out SPL, r16 ; an Stapelzeiger


;CONFIGURE SNES PINS
	.equ channel_switch = 0 ;PORTD.0
	.equ latch = 2
	.equ clock = 3
	.equ data = 0
;pullup for channel_switch:
	ldi r16, (1<<channel_switch)|(1<<clock)|(1<<latch)
	out portd, r16
;data = output
	ldi r16, (1<<data)
	out DDRC, r16

;VARIABLES FOR RECEIVED BUTTONS
	.equ ID = SRAM_START+1
	.equ BUTTONS1 = SRAM_START+2
	.equ BUTTONS2 = SRAM_START+3
	.equ CHANNEL = SRAM_START+4
	.equ NES = SRAM_START+5
	ldi r16, 0xff
	sts nes, r16


	rcall channel_select


;CONFIG SPI PINS
;SCK output ;MISO input;MOSI output;SS output;CE output;IRQ input
	.equ ce = 0
	.equ irq = 1
	.equ ss = 2
	.equ mosi = 3
	.equ miso = 4
	.equ sck = 5
	LDI R16,(1<<ce)|(1<<ss)|(1<<mosi)|(1<<sck)
	out DDRB, r16
;Pullups for IRQ + MISO
	ldi r16, (1<<miso)|(1<<irq)
	out PORTB, r16

;CONFIG SPI
; Enable SPI, Master, clockrate f/4, MSB, 
ldi r17,(1<<SPE)|(1<<MSTR)
out SPCR,r17


;CONFIG INT0
ldi r16, 0b0000_1111 	;rising Edge of INT0 = LATCH, rising edge int1 = latch
out MCUCR, r16
ldi r16, 0b1100_0000
out GICR, r16
sei



;CONFIG NRF
rcall setup_nrf



main:
;***CHECK IF CHANNEL HAS BEEN CHANGED
check_channel:
	lds r16, channel
	sbis pind,channel_switch
	rjmp channel_switch_high

channel_switch_low:
	ldi r17, 109
	sub r17, r16
	BRNE wrong_channel ;FALSCHER KANAL
	RJMP check_channel_end ;RICHTIGER KANAL

channel_switch_high:
	ldi r17, 119
	sub r17, r16
	BRNE wrong_channel
	RJMP check_channel_end

wrong_channel:
	rcall channel_select
	rcall setup_nrf

check_channel_end:


;IF IRQ=1 THEN GOTO MAIN
	in r16, pinb
	sbrc r16, 1
	rjmp main
;IF IRQ=0 THEN:
	RESET_CE
read_fifo:
	RESET_SS
	ldi r17, rd_rx_pload
	rcall do_spi
	rcall do_spi
	sts ID, r17
	rcall do_spi
	sts BUTTONS1, r17
	rcall do_spi
	sts BUTTONS2, r17
		;------------------------
		;NEW
		ANALOG_DATA:
		rcall do_spi	;analog Data verwerfen
		rcall do_spi
		ANALOG_DATA_END:
		;------------------------
	SET_SS
	rcall translate_buttons
;read fifo status
RESET_SS
ldi r17, fifo_status
rcall do_spi
rcall do_spi
SET_SS
sbrs r17, 0
rjmp read_fifo
;IF FIFO=EMPTY THEN CLEAR RX_DR BIT
RESET_SS
ldi r17, write_reg+status
rcall do_spi
ldi r17, 0b01000000
rcall do_spi
SET_SS
SET_CE
rjmp main



;----------------------ISR0-LATCH---------------------------
;------------------aktuelle buttons laden-------------------
isr0:
	in r24, sreg ;save status register

	lds r20, nes	;snes1 laden
	out portc, r20	;ausgabe	
	lsr r20			;right shift
	
isr0_end:
	out sreg, r24 ;write back status register
	reti
;---------------------ISR0 END-------------------------------------------
;------------------------------------------------------------------------


;---------------------ISR1-------------------------------------------
;--------------------------------------------------------------------
ISR1:
	in r24, sreg ;save status register
	
	
	out portc, r20	;ausgabe	
	lsr r20			;right shift
	
ISR1_END:
	out sreg, r24 ;write back status register
	reti
;--------------------ISR1 END----------------------------------------
;------------------------------------------------------------------



;------------------SETUP NRF----------------------------------------
;-------------------------------------------------------------------
;every new command must be started with a high to low transition of CSN (SS)
setup_nrf:
		SET_CE
		rcall wait10ms
		RESET_CE

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+rx_addr_p0
		rcall do_spi
		ldi r17, 0x34
		rcall do_spi
		ldi r17, 0x43
		rcall do_spi
		ldi r17, 0x10
		rcall do_spi
		ldi r17, 0x10
		rcall do_spi
		ldi r17, 0x01
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+en_aa
		rcall do_spi
		ldi r17, 0x01
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+en_rxaddr
		rcall do_spi
		ldi r17, 0x01
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+rf_ch	;CHANNEL
		rcall do_spi
		LDS r17, CHANNEL ;LOAD CHANNEL
		;ldi r17 , 50
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+rx_pw_p0 ;PAYLOAD WIDTH
		rcall do_spi
		ldi r17, 5	;OLD:3
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+rf_setup
		rcall do_spi
		ldi r17, 0b0000_1110	;2MPS datarate
		rcall do_spi

		SET_SS
		rcall delay7
		RESET_SS
		ldi r17, write_reg+config_nrf
		rcall do_spi
		ldi r17, 0x0F
		rcall do_spi

		SET_SS
		rcall wait10ms
		SET_CE
		ret
;-------------------SETUP NRF END------------------
;----------------------------------------------------



;-------------------SPI ROUTINE--------------------
;--------------------------------------------------
do_spi:
	out spdr, r17 ;write out(x) in SPI data register
	spi_not_complete:
	sbis spsr, spif ;if SPI interrupt flag isn't set, then wait
	rjmp spi_not_complete
	in r17, spdr
ret
;--------------------SPI ROUTINE END------------------
;-----------------------------------------------------



;-----------------TRANSLATE BUTTONS------------------------------------------
;----------------------------------------------------------------------------
translate_buttons:
;<-------------------------BUTTONS1------------------------->   <-------------------BUTTONS2---------------------------->
;UP    DOWN    LEFT    RIGHT    SELECT   START    A      B   |||   C      X      Y      Z      L1      L2      R1      R2
;7       6       5       4        3        2      1      0   |||   7      6      5      4       3       2       1       0
;<--------------------------NES1--------------------------->   
;RIGHT  LEFT   DOWN      UP     START    SELECT   Y      B   ||
;7       6       5       4        3        2      1      0   ||
		lds r16, buttons1
		lds r17, buttons2
		ser r18	;nes buttons zurcksetzen

		sbrs r16, 4	;NES RIGHT = RIGHT
		cbr	r18, (1<<7)
		sbrs r16, 5	;NES LEFT = LEFT
		cbr	r18, (1<<6)
		sbrs r16, 6	;NES DOWN = DOWN
		cbr	r18, (1<<5)
		sbrs r16, 7	;NES UP = UP
		cbr	r18, (1<<4)
		sbrs r16, 2	;NES START = START
		cbr	r18, (1<<3)
		sbrs r16, 3	;NES SELECT = SELECT
		cbr	r18, (1<<2)
		sbrs r17, 6	;NES B = X
		cbr	r18, (1<<1)
		sbrs r16, 1	;NES A = A
		cbr	r18, (1<<0)

CHECK_ID:
		lds r16, id
		ldi r17, 0x03 ;n64
		sub r17, r16
		breq TWEAK_N64
		ldi r17, 0x04 ;NES
		sub r17, r16
		breq TWEAK_NES
		ldi r17, 0x02 ;SATURN
		sub r17, r16
		breq TWEAK_SATURN

TWEAK_N64:
		lds r16, buttons2
		sbrs r16, 2	;nur wenn L2=N64-Z gedrckt, ansonsten berspringen
		cbr	r18, (1<<2)
		rjmp translate_buttons_end
TWEAK_NES:
		
		sbr r18, (1<<0)|(1<<1) ;A und B knopf wieder zurcksetzen
		lds r16, buttons1
		sbrs r16, 0	;B gedrckt, ansonsten berspringen
		cbr	r18, (1<<0)
		sbrs r16, 1	;a gedrckt, ansonsten berspringen
		cbr	r18, (1<<1)
		rjmp translate_buttons_end
TWEAK_SATURN:
		sbr r18, (1<<0)|(1<<1) ;A und B knopf wieder zurcksetzen
		lds r16, buttons1
		sbrs r16, 0	;B gedrckt, ansonsten berspringen
		cbr	r18, (1<<0)
		sbrs r16, 1	;a gedrckt, ansonsten berspringen
		cbr	r18, (1<<1)
		lds r16, buttons2	;select knopf = saturn L oder R
		sbrs r16, 3	;L
		cbr	r18, (1<<2)
		sbrs r16, 1	;R
		cbr	r18, (1<<2)
		rjmp translate_buttons_end	


			
translate_buttons_end:
		sts nes, r18	
		ret
;----------------TRANSLATE BUTTONS END------------------------
;-------------------------------------------------------------



;------------------CHANNEL_SELECT-------------------------------
;---------------------------------------------------------------
channel_select:
		ldi r16, 109
		sbis pind, channel_switch
		ldi r16, 119
		sts channel, r16
		ret
;-----------------CHANNEL_SELECT END----------------------------
;---------------------------------------------------------------



;-----------WAIT SUBROUTINES_----------------------------------
;--------------------------------------------------------------
delay7:
	ret
delay14:
	rcall delay7
	ret
delay16:
	rcall delay7
	nop
	nop
	ret
delay46:
	rcall delay16
	rcall delay16
	rcall delay7
	ret
delay62:
	rcall delay16
	rcall delay16
	rcall delay16
	rcall delay7
	ret
delay84:
	rcall delay62
	rcall delay14
	nop
	ret
delay94:
	rcall delay62
	rcall delay14
	rcall delay7
	nop
	nop
	nop
	nop
	ret
wait10ms:
	ldi r16, 10
	wait10times:
		ldi r31, high(4000)
		ldi r30, low(4000)
		msloop:
		sbiw r30, 1
		brne msloop
	dec r16
	brne wait10times
	ret	
;---------WAIT ROUTINES END------------------------------------------
;------------------------------------------------------------------	



