;=== Constants ===
;Define nRF24L01 interrupt flag;s
.equ Idle_int = 0x00                                       ;Idle, no interrupt pending
.equ Max_rt = 0x10                                         ;Max #of Tx Retrans Interrupt
.equ Tx_ds = 0x20                                          ;Tx Data Sent Interrupt
.equ Rx_dr = 0x40                                          ;Rx Data Received
;SPI(nRF24L01) commands
.equ Read_reg = 0x00                                       ;Define Read Command To Register
.equ Write_reg = 0x20                                      ;Define Write Command To Register
.equ Rd_rx_pload = 0x61                                    ;Define Rx Payload Register Address
.equ Wr_tx_pload = 0xA0                                    ;Define Tx Payload Register Address
.equ Flush_tx = 0xE1                                       ;Define Flush Tx Register Command
.equ Flush_rx = 0xE2                                       ;Define Flush Rx Register Command
.equ Reuse_tx_pl = 0xE3                                    ;Define Reuse Tx Payload Register Command
.equ Nop_comm = 0xFF                                       ;Define No Operation , Might Be Used To Read Status Register
;SPI(nRF24L01) registers(addresses)
.equ Config_nrf = 0x00                                     ;Config; register address
.equ En_aa = 0x01                                          ;Enable Auto Acknowledgment; register address
.equ En_rxaddr = 0x02                                      ;Enabled RX addresses; register address
.equ Setup_aw = 0x03                                       ;Setup address width; register address
.equ Setup_retr = 0x04                                     ;Setup Auto. Retrans; register address
.equ Rf_ch = 0x05                                          ;RF channel; register address
.equ Rf_setup = 0x06                                       ;RF setup; register address
.equ Status = 0x07                                         ;Status; register address
.equ Observe_tx = 0x08                                     ;Observe TX; register address
.equ Cd = 0x09                                             ;Carrier Detect; register address
.equ Rx_addr_p0 = 0x0A                                     ;RX address pipe0; register address
.equ Rx_addr_p1 = 0x0B                                     ;RX address pipe1; register address
.equ Rx_addr_p2 = 0x0C                                     ;RX address pipe2; register address
.equ Rx_addr_p3 = 0x0D                                     ;RX address pipe3; register address
.equ Rx_addr_p4 = 0x0E                                     ;RX address pipe4; register address
.equ Rx_addr_p5 = 0x0F                                     ;RX address pipe5; register address
.equ Tx_addr = 0x10                                        ;TX address; register address
.equ Rx_pw_p0 = 0x11                                       ;RX payload width, pipe0; register address
.equ Rx_pw_p1 = 0x12                                       ;RX payload width, pipe1; register address
.equ Rx_pw_p2 = 0x13                                       ;RX payload width, pipe2; register address
.equ Rx_pw_p3 = 0x14                                       ;RX payload width, pipe3; register address
.equ Rx_pw_p4 = 0x15                                       ;RX payload width, pipe4; register address
.equ Rx_pw_p5 = 0x16                                       ;RX payload width, pipe5; register address
.equ Fifo_status = 0x17                                    ;FIFO Status Register; register address

.equ feature = 0x1d
.equ EN_DPL = 2

.equ DYNPD = 0x1c
.equ DPL_P0 = 0
.equ DPL_P1 = 1
.equ DPL_P2 = 2
.equ DPL_P3 = 3
.equ DPL_P4 = 4
.equ DPL_P5 = 5


;Various
.equ True = 1
.equ False = 0

.MACRO LED_OFF
SBI portc, 2
.ENDMACRO

.MACRO LED_ON
CBI portc, 2
.ENDMACRO

.MACRO SET_SS
SBI portb, 2
.ENDMACRO

.MACRO RESET_SS
CBI portb, 2
.ENDMACRO

.MACRO SET_CE
SBI portb, 0
.ENDMACRO

.MACRO RESET_CE
CBI portb, 0
.ENDMACRO

